// sample.cpp
// clang++ -o sample -O3 sample.cpp -std=c++23 -fxray-instrument -fxray-instruction-threshold=1
// XRAY_OPTIONS="patch_premain=true xray_mode=xray-basic" ./sample
#include <iostream>
#include <chrono>
#include <thread>

using namespace std::chrono_literals;

[[clang::xray_always_instrument]] void delay(int i) {
    std::this_thread::sleep_for(i%7? 12ms : 10ms);
}

[[clang::xray_always_instrument]] void f(int i) {
    std::cerr << '.';
    delay(i);
}

[[clang::xray_always_instrument]] void g() {
    for (int i = 0; i < 1 << 10; ++i) {
        std::cerr << '-';
        delay(7);
    }
}

int main(int argc, char* argv[]) {
    std::thread t1([] {
        for (int i = 0; i < 1 << 10; ++i)
            f(i);
    });
    std::thread t2([] {
        g();
    });
    t1.join();
    t2.join();
    std::cerr << '\n';
}
